#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
extern "C" void exit(...);
extern "C" void *malloc(...);
#endif

#include "tof77.h"

#include "compilerApi.h"


Flag in_main_program = off;
Flag in_procedure = off;
Flag in_function=off;

char * mixstring="pcrc";

int do_level = 0;

PassType passtype;

SgFile * global_file;

int silentFlag = 0;

extern void add_attr_stmt(SgStatement * s);
extern void add_data_stmt(SgStatement * s);
extern void function2subroutine(SgStatement *);
extern void assign_replace(SgStatement *);
extern void funccall2sub(SgStatement *);
extern void analyse3(SgStatement *);
extern void analyse4(SgStatement *);
extern void analyse5(SgStatement *);
extern void analyse6(SgStatement *);
extern void analyse7(SgStatement *);

char    *get_file_out(char *file_in)
{       char    *file_out;
        int     i=0;


        file_out=(char *)malloc((unsigned)(strlen(file_in)+5));
        while (file_in[i]!='.') 
        {       file_out[i]=file_in[i];
                i++;
        }
        file_out[i]='\0';
        file_out=strcat(file_out,"_r.dep");
        return(file_out);

}



//the first analyse   
void analyse1(SgStatement * s)
{
  switch(s->variant()) {

  case GLOBAL:
    {
      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];


      int i;

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);
      for (i=0; i<org_numberOfChildren; i++)
	analyse1(children[i]);
      
      delete [] children;

      break;
    };

  case PROG_HEDR:
    {
      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      int i; 

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);

      // do nothing?;
      in_main_program=on;

      for (i=0; i<org_numberOfChildren; i++)
	analyse1(children[i]);
      
      delete [] children;

      in_main_program=off;
	
      break;

    };

  case IMPL_DECL:
     {
       if(s->expr(0)==NULL)
          s->deleteStmt( );
       break;
    }

  case PROC_HEDR:
    {
      SgProcHedrStmt * prochedr = (SgProcHedrStmt *)s;
      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      int i;

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);

      in_procedure=on;
/*
      for (i=0; i<prochedr->numberOfParameters(); i++) {
	prochedr->parameter(i)->addAttribute(DUMP_Def, NULL, 0);
	prochedr->addAttribute(DUMP_Def, NULL, 0);
      }
*/

      for (i=0; i<org_numberOfChildren; i++)
	analyse1(children[i]);
      
      delete [] children;
      
      in_procedure = off;

      break;
    };

  case FUNC_HEDR:
    {
      SgFuncHedrStmt * prochedr = (SgFuncHedrStmt *)s;
      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      int i;

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);

      in_function=on;
      
/*
      for (i=0; i<prochedr->numberOfParameters(); i++) {
	prochedr->parameter(i)->addAttribute(DUMP_Def, NULL, 0);
	prochedr->addAttribute(DUMP_Def, NULL, 0);
      }
*/

      for (i=0; i<org_numberOfChildren; i++)
	analyse1(children[i]);
      
      delete [] children;
      
      in_function = off;

      break;
    }

  case COMBINED_DIRECTIVE_DECL:
    break;

  case PROCESSORS_STMT:
//    analyse_processor(s);
    break;

  case TEMPLATE_STMT:
//    analyse_template(s);
    break;

  case ALIGN_DECL:
    break;
    
  case DISTRIBUTE_DECL:
//    analyse_distribute(s);
    break;

  case INHERIT_DECL:
//    analyse_inherit(s);
    break;

  case VAR_DECL:
       { 
           SgExpression * exprlist=NULL;
           
           add_attr_stmt(s); 

               //motify  s->expr(2)
           for(SgExpression *exp=s->expr(2); exp; exp=exp->rhs())
             {  
                switch(exp->lhs()->variant())
                { 
                 case ALLOCATABLE_OP:
                 case POINTER_OP:
                 case OPTIONAL_OP:
                 case INHERIT_OP:
                 case DYNAMIC_OP:
                     { SgExpression * var=exp->lhs()->copyPtr();
                       exprlist=new SgExpression(EXPR_LIST,var,exprlist,NULL);
                       break;
                      }
                }
             } //end for

           s->thebif->entry.Template.ll_ptr3=exprlist?exprlist->thellnd:LLNULL;
/*
           if(exprlist!=NULL)             //attributes that are saved 
            {
               s->expr(2)->setLhs(exprlist->lhs());
               s->expr(2)->setRhs(exprlist->rhs()); 
            }
           else                           //no attribute
              s->thebif->entry.Template.ll_ptr3=NULL;
*/
           break;
    };

  case INTERFACE_STMT:
    //do nothing;
    break;

  case FOR_NODE:
    {
      do_level++;

      int org_numberOfChildren=s->numberOfChildrenList1();

      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      int i;

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);

      for (i=0; i<org_numberOfChildren; i++)
	analyse1(children[i]);
      
      delete [] children;
      
      do_level--;

      break;
    }

  case LOGIF_NODE:
  case ELSEIF_NODE:
  case LOGIF_STMT:
  case SWITCH_NODE:
  case CASE_NODE:
    {
      int org_numberOfChildren1=s->numberOfChildrenList1();

      SgStatement * * children1 = new SgStatement * [org_numberOfChildren1];

      int org_numberOfChildren2=s->numberOfChildrenList2();

      SgStatement * * children2 = new SgStatement * [org_numberOfChildren2];

      int i;

      for (i=0; i<org_numberOfChildren1; i++)
	children1[i]=s->childList1(i);

      for (i=0; i<org_numberOfChildren1; i++)
	analyse1(children1[i]);
      
      delete [] children1;

      for (i=0; i<org_numberOfChildren2; i++)
	children2[i]=s->childList2(i);			

      for (i=0; i<org_numberOfChildren2; i++)
	analyse1(children2[i]);
      
      delete [] children2;

      break;

    }

  case ASSGOTO_NODE:
  case STOP_STAT:
    // do nothing;
    break;


  case PROC_STAT:
    //do nothing at presenttime. we will analyse INTERFACE later;
    break;

  case ASSIGN_STAT:                                                                                                  
//    analyse_assign(s);
    break;

  case FORALL_STMT:
    {       
/*
      analyse_forall_header(s);
      get_forall_reference(s);

      Forall_header_def * fhdef=(Forall_header_def *) s->getAttribute(0, FHDER_Def)->getAttributeData();
    
      for (int i=0; i<fhdef->getindexnumber(); i++) {
	SgSymbol * index=fhdef->getindexsymb(i);
	index_forall_reference(i, index, s->childList1(0));
      };

      detect_forall_reference(s);
*/
      break;
    }

  case PRINT_STAT:
  case WRITE_STAT:
//    analyse_datatransfer(s);
    break;

  case CONTROL_END:
  case PARAM_DECL:
  case ENDDO_STMT:
  case  FORMAT_STAT:
   // statement need do nothing;
    break;

  default:
//    printf("Not touched statement in analyse on line %d\n", s->lineNumber());
    break;
  };

}

void analyse2(SgStatement * s)
{
  switch(s->variant())
  {
    case GLOBAL:
      {
         int org_numberOfChildren=s->numberOfChildrenList1();
         SgStatement * * children=new SgStatement * [org_numberOfChildren];

         int i;

         for(i=0;i<org_numberOfChildren;i++)
             children[i]=s->childList1(i);
         for(i=0;i<org_numberOfChildren;i++)
             analyse2(children[i]);

        delete [] children;

        break;
      };

   case PROG_HEDR:
      { 
         int org_numberOfChildren=s->numberOfChildrenList1();
         SgStatement * * children=new SgStatement * [org_numberOfChildren];

         int i;

         for(i=0;i<org_numberOfChildren;i++)
             children[i]=s->childList1(i); 

         in_main_program=on;

         for(i=0;i<org_numberOfChildren;i++)
             analyse2(children[i]);

         delete [] children;

         in_main_program=off;
  
         break;
       };

   case PROC_HEDR:
      {
        SgProcHedrStmt * prochedr=(SgProcHedrStmt *)s;
        int org_numberOfChildren=s->numberOfChildrenList1();
        SgStatement * * children=new SgStatement * [org_numberOfChildren];

        int i;

        for(i=0;i<org_numberOfChildren;i++)
            children[i]=s->childList1(i);

        in_procedure=on;

        for(i=0;i<org_numberOfChildren;i++)
             analyse2(children[i]);
     
        delete [] children;

        in_procedure=off;

        break;
      };

    case FUNC_HEDR:
      {
         SgFuncHedrStmt * prochedr=(SgFuncHedrStmt *)s;
         int org_numberOfChildren=s->numberOfChildrenList1();
         SgStatement * * children=new SgStatement * [org_numberOfChildren];

         int i;

         for(i=0;i<org_numberOfChildren;i++)
              children[i]=s->childList1(i);

          in_function=on;

         for(i=0;i<org_numberOfChildren;i++)
             analyse2(children[i]);

         delete [] children;

         in_function=off;

         break;
      };  
   case VAR_DECL:
      {
        add_data_stmt(s);
        break;
      }; 
     
  }
 
}

static void usage()
{
        printf("Usage: tof77 [-h|--help] [-z] HPF_file.dep \n");
	printf("options:\n");
        printf("   -h|--help   : help message. \n");
        printf("   -z          : suppress all compiling message.\n");
}

void parse_string(char *s)
{
        if (strncmp(s,"help",4) == 0) {
		usage();
		exit(0);
        }
        else 
                printf("warning : Unknown option \"%s\" ignored.\n",s);
}

main(int argc, char * argv[]) 
{
  SgProject * project;
  char *file_in , *file_out;
  PassType  pt[20];
  int no,i,j;

	argv++;
        argc--;
	if (argc == 0) { usage(); exit(1); }
	no = 0;
        while ((argc > 0) && ((*argv)[0] == '-') )
        {
                i=1;
                while (argv[0][i] != '\0') {
			switch (argv[0][i]) {
			case 'a':
				pt[no++]=DECLARATION_PASS; break;
			case 'b':
				pt[no++]=FUNCTION_HEDR_PASS; break;
			case 'c':
				pt[no++]=DO_WHILE_PASS; break;
			case 'd':
				pt[no++]=CASE_STMT_PASS; break;
			case 'e':
				pt[no++]=RECORD_PASS; break;
			case 's':
				pt[no++]=SERIALIZE_PASS; break;
			case 'z':
				silentFlag = 1; break;
			case 'h':
				usage() ; exit(0);
			case '-':
                                if (i==1) {
                                        parse_string(argv[0]+i+1);
                                        i=strlen(argv[0])-1;   /* quit loop */
                                }
                                break;
			default:
                                printf("warning 422: Unknown option \"%c\" ignored.\n",argv[0][i]);
				exit(1);
			}
			i++;
		}
		argc--;
		argv++;
	}
  // fot debug, change forall stmt to do-loop , and delete 
  if (no == 1 && pt[0] == SERIALIZE_PASS)
  {
	no = 0;
	pt[no++]=DECLARATION_PASS;
	pt[no++]=FUNCTION_HEDR_PASS;
#ifndef FORTRAN_DO_WHILE
	pt[no++]=DO_WHILE_PASS;
#endif
#ifndef FORTRAN_SELECTCASE
	pt[no++]=CASE_STMT_PASS;
#endif
	pt[no++]=RECORD_PASS;
	pt[no++]=SERIALIZE_PASS;
  }
  if ( no == 0 )
  {
	pt[no++]=DECLARATION_PASS;
	pt[no++]=FUNCTION_HEDR_PASS;
#ifndef FORTRAN_DO_WHILE
	pt[no++]=DO_WHILE_PASS;
#endif
#ifndef FORTRAN_SELECTCASE
	pt[no++]=CASE_STMT_PASS;
#endif
	pt[no++]=RECORD_PASS;
  }

  argc++; argv--;
  project = new SgProject("test", argc, argv);

  for (i=0; i< project->numberOfFiles(); i++) {

    global_file = &(project->file(i));
    file_in=global_file->filept->filename;

    SgStatement * s;

    for ( j=0; j<no ; j++)
    {
	passtype=pt[j];

    	s = global_file->firstStatement();

	switch (passtype) {
	case DECLARATION_PASS:
		if (!silentFlag)
		printf("*** Process declaration statement. ***\n");
    		analyse1(s); analyse2(s); break;
	case FUNCTION_HEDR_PASS:
		if (!silentFlag)
		printf("*** Process function header . ***\n");
		analyse3(s); break;
	case DO_WHILE_PASS:
		if (!silentFlag)
		printf("*** Process do while statement . ***\n");
		analyse4(s);
		break;
	case CASE_STMT_PASS:
		if (!silentFlag)
		printf("*** Process case statement . ***\n");
		analyse5(s);
		break;
	case SERIALIZE_PASS:
		if (!silentFlag)
		printf("*** Serialize parallel statement . ***\n");
		analyse6(s);
		break;
	case RECORD_PASS:
		if (!silentFlag)
		printf("*** Process record declarations . ***\n");
		analyse7(s);
		break;
	}
    }

    file_out=get_file_out(file_in);
    global_file->saveDepFile(file_out);
    
  };

  return 0;
}



